//******************************************************************************
//  Секция include: здесь подключается заголовочный файл к модулю
//******************************************************************************

#include "genkey.h" // заголовочный *.h файл текущего проекта

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//           начальная настройка дисплея
/* 
 *  настройка индикатора "по умолчанию"
 *  сканирование всех 8 позиций
 *  режим знакосинтеза
 *  яркость~50%
 *  исходно позиции заполнены "пробелами"
 */
void disp_init()
{
  my72.write(Disp_ts, Com_tst_on_md);
// Dec_Mod, все позиции только под знакосинтез DM отключен
  my72.write(Dec_Mod, Com_DM_0);
// Intensit, уровень яркости 23/32
  my72.write(Intensit, Com_int_B);
// Sc_Lim, индикация только в позиции 0,1,2,3,4,5,6,7
  my72.write(Sc_Lim, Com_SL_7);
// Shut_Dn, значение данных команды Normal_mode
  my72.write(Shut_Dn, Com_Normal_md);
  for (byte cnt=0; cnt<=7; cnt++)
  {
    my72.v_ram[cnt]=fnt_minus;
  }
  my72.write_s();
// Disp_ts, значение данных команды display test off_mode
  my72.write(Disp_ts, Com_tst_of_md);
// Intensit, уровень яркости 15/32
  my72.write(Intensit, Com_int_7);
  delay(1500);
}

//------------------------------------------------------------------------
//                главные часы
//        (обеспечение отсчета и индикации)

// контроль и приращение счетчиков размещено в прерывании
// дополнительной тайм-сетки

// инициализация данных главных часов
volatile byte G_ClkF = 0; // байт флагов главных часов
volatile byte GcntS = 0; // счетчик секунд главных часов
volatile byte GcntM = 0; // счетчик минут главных часов
volatile byte GcntH = 0; // счетчик часов главных часов

//.....................................................................
// функция обработчика контроля и приращения
// счетчиков главных часов
void Gclock_work()
 {
  if (bitRead(G_ClkF, En_Clock))
      {
       GcntS++; bitSet(G_ClkF, Qt_ClkInd);
        if (GcntS==mod60)
         {
          GcntS =0; GcntM++; bitSet(G_ClkF, Qt_work);
           if (GcntM==mod60)
            {
             GcntM =0; GcntH++;
              if (GcntH==mod24){GcntH =0;}
            }
         }
      // тут и же обработчик будильников по G_ClkF.Qt_work
      }
 }

//.....................................................................
// вывод на индикацию показаний главных часов
void Gclock_ind()
{
 if (bitRead(G_ClkF, En_ClkInd))
  {
   my72.v_ram[(GclkInd_1 - 1)] = fnt_minus;
   my72.v_ram[(GclkInd_2 - 1)] = fnt_minus;
    if (GcntS >= 10)
     {
      my72.v_ram[(GclkIndSh - 1)] = Gclock_iZnak((GcntS/10));
      my72.v_ram[(GclkIndSl - 1)] = Gclock_iZnak((GcntS-((GcntS/10)*10)));
     }
    else 
     {
      my72.v_ram[(GclkIndSh - 1)] = fnt_0;
      my72.v_ram[(GclkIndSl - 1)] = Gclock_iZnak(GcntS);
     }
    if (GcntM >= 10)
     {
      my72.v_ram[(GclkIndMh - 1)] = Gclock_iZnak((GcntM/10));
      my72.v_ram[(GclkIndMl - 1)] = Gclock_iZnak((GcntM-((GcntM/10)*10)));
     }
    else 
     {
      my72.v_ram[(GclkIndMh - 1)] = fnt_0;
      my72.v_ram[(GclkIndMl - 1)] = Gclock_iZnak(GcntM);
     }
    if (GcntH >= 10)
     {
      my72.v_ram[(GclkIndHh - 1)] = Gclock_iZnak((GcntH/10));
      my72.v_ram[(GclkIndHl - 1)] = Gclock_iZnak((GcntH-((GcntH/10)*10)));
     }
    else 
     {
      my72.v_ram[(GclkIndHh - 1)] = fnt_bl;
      my72.v_ram[(GclkIndHl - 1)] = Gclock_iZnak(GcntH);
     }
   my72.write_s(); // вывод v_ram в индикатор
  }
 bitClear(G_ClkF, Qt_ClkInd); // сброс флага запроса в любом случае
}


//.....................................................................
// декодер байт со значением в формате двоичной тетрады (0х0N)
// в байт знакосинтеза max7219
byte Gclock_iZnak(byte tmp)
{ byte tmpp;
  switch (tmp) {
   case 0:
     tmpp=fnt_0;
    break;
   case 1:
     tmpp=fnt_1;
    break;
   case 2:
     tmpp=fnt_2;
    break;
   case 3:
     tmpp=fnt_3;
    break;
   case 4:
     tmpp=fnt_4;
    break;
   case 5:
     tmpp=fnt_5;
    break;
   case 6:
     tmpp=fnt_6;
    break;
   case 7:
     tmpp=fnt_7;
    break;
   case 8:
     tmpp=fnt_8;
    break;
   case 9:
     tmpp=fnt_9;
    break;
   case 10:
     tmpp=fnt_A;
    break;
   case 11:
     tmpp=fnt_b;
    break;
   case 12:
     tmpp=fnt_C;
    break;
   case 13:
     tmpp=fnt_d;
    break;
   case 14:
     tmpp=fnt_E;
    break;
   case 15:
     tmpp=fnt_F;
    break;
   default: 
     tmpp=fnt_bl;
   break;
   };
   return tmpp;
}

//------------------------------------------------------------------------
//           обработчики общего функционала клавиатуры

// регистр флагов блокировки повторного исполнения до
// полного отпускания кнопки/комбинации кнопок
volatile byte trig_flags;
// указатель позиции массива технологических данных ("бегунок")
volatile byte window_ptr;
// флаг режима отображения 0 - работа текущего устройства
// 1 - режим отображения меню
volatile byte Fflag = 0;
// флаг признака открытого окна настроек данных
// 0 - окна параметров закрыты
// 1 - окна параметров открыты
volatile byte FflagW = 0;
// флаг "склерозника"
volatile byte skleroz;
// массив флагов разрешенных позиции для кнопок < и >
byte EnWindF[]{0,0,0,0,0,0,0,0};
// массив технологческих данных
byte TehWind[]{0,0,0,0,0,0,0,0};
// массив модулей максимального значения (модуля счета)
// в окне технологических данных
byte ModWind[]{0,0,0,0,0,0,0,0};

//.....................................................................
// минимальная функция обработчика триггеров защиты
// от повторного выполнения задач
//"статус "все кнопки отпущены""
void OllOff()
{
  trig_flags = 0;
  // и обработчик "склерозника"
}

//.....................................................................
// инициализация исходного состояния
// векторного селектора клавиатуры
// для теста цикл заполнения key_block, для реала -
// заполнение массива согласно начальному статусу устройства
void KeyStartInit()
 {
  for (byte i=0; i<=(max_num - 1); i++)
   {
    key_vektor[i]=key_block;
   }
 }

//.....................................................................
// заполнение массива из 8 байт константой
void clr_mas(byte *mas, byte dat)
{
  for (byte i=0; i<=7; i++)
  {
    mas[i]=dat;
  }
}

//.....................................................................
//     кнопка "<"
// перемещение курсора в виде децимальной точки влево по дисплею
void CurLeft()
{
 if (!bitRead(trig_flags, Le_trigF))
  {
   //установить флаг блокировки повторного исполнения
   bitSet(trig_flags, Le_trigF);
   // убрать курсор из текущего байта v_ram
   my72.v_ram[window_ptr] = my72.v_ram[window_ptr] & (~fnt_coma);
   do
    {
      window_ptr++; // инкремент бегунка
      // проверить на верхнюю границу допустимых значений
      if (window_ptr == 8){window_ptr = 0;}
    }while (!EnWindF[window_ptr]); // выход, если EnWindF[window_ptr]=1
   // установить курсор в текущем байте v_ram
   my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
   my72.write_s(); // вывод v_ram в индикатор
  }
 // если активен флаг блокировки повторного исполнения выход
 // (или отработка ускоренного исполнения)
}

//.....................................................................
//     кнопка ">"
// перемещение курсора в виде децимальной точки вправо по дисплею
void CurRight()
{
 if (!bitRead(trig_flags, Ri_trigF))
  {
   //установить флаг блокировки повторного исполнения
   bitSet(trig_flags, Ri_trigF);
   // убрать курсор из текущего байта v_ram
   my72.v_ram[window_ptr] = my72.v_ram[window_ptr] & (~fnt_coma);
   do
    {
      window_ptr--; // декремент бегунка
      // проверить на нижнюю границу допустимых значений
      if (window_ptr == 0xFF){window_ptr = 7;}
    }while (!EnWindF[window_ptr]); // выход, если EnWindF[window_ptr]=1
   // установить курсор в текущем байте v_ram
   my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
   my72.write_s(); // вывод v_ram в индикатор
  }
 // если активен флаг блокировки повторного исполнения выход
 // (или отработка ускоренного исполнения)
}

//.....................................................................
//     кнопка "вверх"
// инкремент значения в разрешенной (флаг в EnWindF[N]) позиции N
// массива технологических данных TehWind[N]
// модуль инкремента в ModWind[N]
void CurUp()
{
 if (!bitRead(trig_flags, Up_trigF))
 {
  bitSet(trig_flags, Up_trigF);
  // селектор действует только для режима главного меню
  // и позиции 0 массива технологических данных
  if (Fflag && (window_ptr == 0))
  {
    // селектор функций ввода параметров в RTC или ОЗУ
    // рабочего параметра устройства
    // при активном окне просмотра/ввода параметров устройства
    // выполняет ввод параметров если корректны с очисткой
    // окна параметров и переносом курсора в позицию ноиера
    // субменю
    // иначе повторно ставит курсор в окно старшего разряда
    // параметров (урезая младший разряд до максимально
    // допустимого)
    // при окне М0 блокирована независимо от значения М
    // в данном случае переход к исполнению избранного
    // устройства выполняется по RK_key
   byte ptrf = (TehWind[6]<<4) | TehWind[5];
   switch (ptrf){
//    case 0x00:
// для устройств вида 0xM0 не используется
//    break;
   case 0x01:
    // возврат к выборке субменю с записью внесенных изменений
    // минуты запись в GcntM и adr_rtc_min
     GClkMw();
    break;
   case 0x02:
    // возврат к выборке субменю с записью внесенных изменений
    // часы запись в GcntH и adr_rtc_hours
     GClkHw();
    break;
   case 0x03:
    // возврат к выборке субменю с записью внесенных изменений
    // день недели запись в adr_rtc_day
     GClkDayw();
    break;
   case 0x04:
    // возврат к выборке субменю с записью внесенных изменений
    // дата запись в adr_rtc_date
     GClkDatew();
    break;
   case 0x05:
    // возврат к выборке субменю с записью внесенных изменений
    // месяц запись в adr_rtc_mons
     GClkMonsw();
    break;
   case 0x06:
    // возврат к выборке субменю с записью внесенных изменений
    // год запись в adr_rtc_year
     GClkEearw();
    break;
   case 0x07:
    // запуск отсчета 00 секунд
     GClkstw();
    break;
//   case 0x10:
// для устройств вида 0xM0 не используется
//    break;
   default: 
     // statements
   break;
   }
  }
  else {
  TehWind[window_ptr] ++;
  if (TehWind[window_ptr] == ModWind[window_ptr])
   {
    TehWind[window_ptr] = 0;
   }
  my72.v_ram[window_ptr] = (Gclock_iZnak(TehWind[window_ptr])) | fnt_coma;
  my72.write_s();
  //''''''''''''''''''''''''''''''''''''''''''''''
  if (TehWind[5] != 0)
    {
     if (FflagW){EnWindF[6] = 0; EnWindF[0] = 1;}
      else {EnWindF[6] = 0; EnWindF[0] = 0;}
    }
   else {EnWindF[6] = 1; EnWindF[0] = 1;}
  //..............................................
  }
 }
}

//.....................................................................
//     кнопка "вниз"
// декремент значения в разрешенной (флаг в EnWindF[N]) позиции N
// массива технологических данных TehWind[N]
// модуль инкремента в ModWind[N]
void CurDn()
{
 if (!bitRead(trig_flags, Dn_trigF))
 {
  bitSet(trig_flags, Dn_trigF);
  // селектор действует только для режима главного меню
  // и позиции 0 массива технологических данных
  if (Fflag && (window_ptr == 0))
  {
    // селектор функций "возврат без параметров" 
    // в RTC или ОЗУ
    // при активном окне просмотра/ввода параметров устройства
    // очищает поле параметров и ставит курсор из TehWind[0]
    // в TehWind[5] (window_ptr=5)
    // при окне М0 выход по содержимому StartFInd к работе
    // предшествующего вызову меню устройства
    // смена устройства на то, что означено в текущих окнах
    // TehWind[6]:TehWind[5] с соответствующей заменой
    // индекса в StartFInd и AdrRtcFInd обеспечивает RK_key
   byte ptrf = (TehWind[6]<<4) | TehWind[5];
   switch (ptrf){
    case 0x00:
     // сброс флага режима меню
     Fflag=0;
     // выполнение старт-актуации устройства согласно
     // предыдущему содержимому StartFInd
      selFind();
    break;
   case 0x01:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x02:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x03:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x04:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x05:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x06:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x07:
    // возврат к выборке субменю без записи внесенных изменений
     GClkMc();
    break;
   case 0x10:
    // сброс флага режима меню
     Fflag=0;
     // выполнение старт-актуации устройства согласно
     // предыдущему содержимому StartFInd
      selFind();
    break;
   default: 
     // statements
   break;
   }
  }
  else {
  TehWind[window_ptr] --;
  if (TehWind[window_ptr] == 0xFF)
   {
    TehWind[window_ptr] = (ModWind[window_ptr] -1);
   }
  my72.v_ram[window_ptr] = (Gclock_iZnak(TehWind[window_ptr])) | fnt_coma;
  my72.write_s();
  //''''''''''''''''''''''''''''''''''''''''''''''
  if (TehWind[5] != 0)
    {
     if (FflagW){EnWindF[6] = 0; EnWindF[0] = 1;}
      else {EnWindF[6] = 0; EnWindF[0] = 0;}
    }
   else {EnWindF[6] = 1; EnWindF[0] = 1;}
  //..............................................
  }
 }
}

//.....................................................................
//     кнопка RK (Exec_key)
// в режиме работы текущего устройства
// обеспечивает переход в главное меню, при
// работе главного меню действует согласно селектора
// функций
void RK_key()
{
  if (!bitRead(trig_flags, Ex_trigF))
 {
  bitSet(trig_flags, Ex_trigF);
  byte tmp_Find;
  // при Fflag=0 читаем индекс из StartFInd
  // при Fflag=1 читаем индекс из данных текущего меню
  // tmp_Find = (TehWind[6]<<4) | TehWind[5]
  if (Fflag) {tmp_Find = (TehWind[6]<<4) | TehWind[5];}
  else {tmp_Find = StartFInd;}
  // 0x0n главные часы
  // 0x1n секундомер
  // 0x2n таймер обратного отсчета
  // 0x3n будильник 1
  // 0x4n будильник 2
  switch (tmp_Find){
   case 0x00:
         // если RK в меню
     if (Fflag){
      Fflag = 0;
      // перезапись индекса на устройство "главные часы"
      StartFInd = 0x00;
      wrbRamRtc(AdrRtcFInd, StartFInd);
      GClkMi();
      }
         // если RK в работающем устройстве
     else{Fflag = 1; GClkMm();}
    break;
   case 0x01:
    // активация режима просмотра/ввода минут RTC и главных часов
     GClkMr();
    break;
   case 0x02:
    // активация режима просмотра/ввода часов RTC и главных часов
     GClkHr();
    break;
   case 0x03:
    // активация режима просмотра/ввода дня недели RTC главных часов
     GClkDayr();
    break;
   case 0x04:
    // активация режима просмотра/ввода числа RTC главных часов
     GClkDater();
    break;
   case 0x05:
    // активация режима просмотра/ввода месяца RTC главных часов
     GClkMonsr();
    break;
   case 0x06:
    // активация режима просмотра/ввода года RTC главных часов
     GClkEearr();
    break;
   case 0x07:
    // активация режима "запуск отсчета 00 секунд"
     GClkstr();
    break;
   case 0x10:
         // если RK в меню
    if (Fflag){
      Fflag=0;
    // перезапись индекса на устройство "секундомер"
      StartFInd = 0x10;
      wrbRamRtc(AdrRtcFInd, StartFInd);
    // запуск работы устройства "секундомер"
      SecMetrI();
     }
         // если RK в работающем устройстве
     else{Fflag = 1; SecMetrM();}
    break;
   case 0x20:
         // если RK в меню
    if (Fflag){
    // Fflag=0;
    // ввод индекса 0x00 в StartFInd и AdrRtcFInd

    // запуск работы устройства "таймер обратного отсчета"
     }
         // если RK в работающем устройстве
    else{
      // останов текущей индикации и вывод
      // окна главного меню с курсором в
      // TehWind[6] (window_ptr=6)
     }
    break;
   case 0x30:
         // если RK в меню
    if (Fflag){
    // Fflag=0;
    // ввод индекса 0x00 в StartFInd и AdrRtcFInd

    // запуск работы устройства "будильник1"
     }
         // если RK в работающем устройстве
    else{
      // останов текущей индикации и вывод
      // окна главного меню с курсором в
      // TehWind[6] (window_ptr=6)
     }
    break;
   case 0x40:
         // если RK в меню
    if (Fflag){
    // Fflag=0;
    // ввод индекса 0x00 в StartFInd и AdrRtcFInd

    // запуск работы устройства "будильник2"
     }
         // если RK в работающем устройстве
    else{
      // останов текущей индикации и вывод
      // окна главного меню с курсором в
      // TehWind[6] (window_ptr=6)
     }
    break;
   default: 
     // statements
   break;
  }
 }
}

//.....................................................................
// общий участок инициализации перехода к главному меню
// от окна текущего работающего устройства
// аргумент - модуль количества субменюшек в устройстве
void masterMM(byte modul5)
{
  // блок инициализации(очистки) для режимов
 // активации окон меню/субменю
  StartIniLabel();
 // установка для разршенных в данном случае
 // окон (позиций) флагов "бегунка"
  EnWindF[6] = 1; EnWindF[5] = 1; EnWindF[0] = 1;
 // исходная позиция "бегунка" (для данного случая
 // "в окне главного меню")
  window_ptr = 6;
 // мoдуль счета для разрешенных позиций главного меню
  ModWind[6] = 5; ModWind[5] = modul5;
 // исходное значение для разрешенных позиций
 // технологических данных берем по содержимому StartFInd
  TehWind[6] = (StartFInd >> 4) & B00001111; TehWind[5] = 0;
 // загрузка заставки "F0,0    ?"
  my72.v_ram[7] = fnt_F;
  my72.v_ram[6] = Gclock_iZnak(((StartFInd >> 4) & B00001111));
  my72.v_ram[6] = my72.v_ram[6] | fnt_coma;
  my72.v_ram[5] = fnt_0;
  my72.v_ram[0] = fnt_qest;
 // с выводом на индикацию
  my72.write_s();
 // активирована кнопы:
  key_vektor[NumV_Zs] = OllOff;
  key_vektor[NumV_Ex] = RK_key;
  key_vektor[NumV_Dn] = CurDn;
  key_vektor[NumV_Up] = CurUp;
  key_vektor[NumV_Ri] = CurRight;
  key_vektor[NumV_Le] = CurLeft;
}

//------------------------------------------------------------------------
//           иные общие функции

//.....................................................................
// блок инициализации для режимов активации
// окон меню (субменю)
void StartIniLabel()
{
 // векторный селектора клавиатуры блокирован
  KeyStartInit();
 // предочистка массива флагов разрешенных
 // позиции для кнопок '<' и '>'
  clr_mas(EnWindF, 0);
 // предочистка массива технологческих данных
  clr_mas(TehWind, 0);
 // предочистка массива модулей максимального значения (модуля счета)
 // в окне технологических данных
  clr_mas(ModWind, 1);
 // предочистка массива v_ram
  clr_mas(my72.v_ram, fnt_bl);
}

//.....................................................................
// останов по критической ошибке
// аргументами ставим символы номера/кода ошибки
// вывод данных непосредствено в v_ram
void ErrorStop(byte eriH, byte eriL)
{
  // сброс всех рабочих режимов
  // с декативацией силовых/управляющих
  // линий для внешних устройств
  StartIniLabel();
  // вывод сообщения об ошибке с
  // номером источника возникновения
  my72.v_ram[7] = fnt_E;
  my72.v_ram[6] = fnt_r;
  my72.v_ram[5] = fnt_r;
  my72.v_ram[4] = fnt_o;
  my72.v_ram[3] = fnt_r;
  my72.v_ram[1] = eriH;
  my72.v_ram[0] = eriL;
  my72.write_s(); // вывод v_ram в индикатор
  // останов до отключения питания
  while (1)
  { }
}

//.....................................................................
// запись одного байта в RAM RTC по заданному адресу
void wrbRamRtc(byte adr, byte data)
{
  byte errorTmp;
  my_iic.mx_Start();
  errorTmp = my_iic.mx_Txd(Nw_ds1307);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  errorTmp = my_iic.mx_Txd(adr);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  errorTmp = my_iic.mx_Txd(data);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  my_iic.mx_Stop();
}

//.....................................................................
// чтение одного байта в RAM RTC по заданному адресу
byte rdbRamRtc(byte adr)
{ byte tmp;
  //считать AdrRtcFInd в StartFInd из RAM RTC
  byte errorTmp;
  my_iic.mx_Start();
  errorTmp = my_iic.mx_Txd(Nw_ds1307);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  errorTmp = my_iic.mx_Txd(adr);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  my_iic.mx_reStart();
  errorTmp = my_iic.mx_Txda(Nr_ds1307);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  tmp = my_iic.mx_Rxd(mx_noAck);
  my_iic.mx_Stop();
  return tmp;
}

//.....................................................................

//       обработчик актуатора по подаче питания

//.....................................................................

// индекс указателя на функцию-актуатор текущего устройства
// (файла) при включении устройства
// после первичной загрузки ColdStart() соответствует
// статусу "запуск индикации главных часов"
// значение из двух тетрад 0xMN, где
// M - номер устройства, а N - номер субменю, который
// в данном случае всегда равен 0
// 
volatile byte StartFInd;

// селектор запуска устройств согласно индекса в StartFInd
// аналогия запуска "RK в меню"
void selFind()
{
  switch (StartFInd) {
   case 0x00:
      GClkMi(); // главные часы
     break;
   case 0x10:
     SecMetrI(); // секундомер
     break;
   case 0x20:
     // таймер обратного отсчета
     break;
   default: 
     GClkMi(); // главные часы
   break;
  }
}

//.....................................................................
// обработчик "холодного старта" - загрузки в RTC индекса на
// статус загрузки параметров из RTC для индикации отсчета
// главных часов
void ColdStart()
{
 if (!digitalRead(Exec_key))
 {
  StartFInd=0;
  wrbRamRtc(AdrRtcFInd, StartFInd);
  // настройка режима работы для adr_rtc_control
  // пассивное состояние rtc_sqw = 1,
  // частота на rtc_sqw = 1Гц,
  // работа выхода разрешена
  byte temp = (1<<adr_OUT_bit) | (1<<adr_SQWE_bit);
  wrbRamRtc(adr_rtc_control, temp);
  // 24 часовый режим устанавливается при вводе значения часов
  // запуск хода RTC в пункте 0x08 главного меню
  digitalWrite(Led_Out, HIGH);
  delay(1500);
  while (!digitalRead(Exec_key))
  {
    delay(50);
  }
  digitalWrite(Led_Out, LOW);
 }
}

//------------------------------------------------------------------------

//-------------конец файла/end of file---------------------
