//******************************************************************************
//  Секция include: здесь подключается заголовочный файл к модулю
//******************************************************************************

#include "myclock.h" // заголовочный *.h файл текущего проекта

//------------------------------------------------------------------------

//                   главные часы G_Clock

//------------------------------------------------------------------------

//.....................................................................
// запуск функции активации главного меню
// из работающего окна индикации устройства
// "главные часы" (индекс в StartFInd = 0x00)
// курсор в окне главных меню устройств
void GClkMm()
{
 // заблокированы в пассивном состоянии
 // внешние силовые выводы

 // запрещена индикация главных часов при
 // сохранении хода
  G_ClkF = G_ClkF & (~En_ClkInd);
 // мoдуль счета для разрешенных позиций субменю
 // передается аргументом в masterMM
 // ModWind[5] = 8;
  masterMM(8);
}

//.....................................................................
// запуск функции активации рабочего режима
// устройства "главные часы"
// (индикация показаний)
// индекс в StartFInd и ячейке AdrRtcFInd
// заменяется на 0x00
void GClkMi()
{
 // разблокированы (возвращен текущий статус)
 // внешние силовые выводы

 // запрещены ход и индикация главных часов (страховка)
  G_ClkF=G_ClkF & (!((1<<En_Clock) | (1<<En_ClkInd)));
 // инициализация исходного состояния (блокировка)
 // векторного селектора клавиатуры и селектора меню
  StartIniLabel();
 // считать данные из RTC в GcntS, GcntM и GcntH
  byte errorTmp;
  my_iic.mx_Start();
  errorTmp = my_iic.mx_Txd(Nw_ds1307);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  errorTmp = my_iic.mx_Txd(adr_rtc_sec);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  my_iic.mx_reStart();
  errorTmp = my_iic.mx_Txda(Nr_ds1307);
   // обработчик ошибки при errorTmp=1
   if (errorTmp){my_iic.mx_Stop(); ErrorStop(fnt_L,fnt_I);}
  GcntS = my_iic.mx_Rxd(mx_Ack);
  GcntM = my_iic.mx_Rxd(mx_Ack);
  GcntH = my_iic.mx_Rxd(mx_noAck);
  my_iic.mx_Stop();
 // преобразовать данные из двоично-десятичного в двоичный формат
  GcntS = (((GcntS >> 4) & B00000111) * 10) + (GcntS & B00001111);
  GcntM = (((GcntM >> 4) & B00001111) * 10) + (GcntM & B00001111);
  GcntH = (((GcntH >> 4) & B00001111) * 10) + (GcntH & B00001111);
 // предочистка массива v_ram с выводом на индикацию
  clr_mas(my72.v_ram, fnt_bl); my72.write_s();
 // разрешены ход и индикация главных часов
  G_ClkF=(1<<En_Clock) | (1<<En_ClkInd);
 // разрешено обслуживание кноп
  key_vektor[NumV_Zs] = OllOff;
  key_vektor[NumV_Ex] = RK_key;
}

//.....................................................................
// функции режима просмотра/ввода значений
// субменю главных часов

// просмотр/редактрование значений минут (00-59)
// курсор в окне субменю устройста
// RK при открытом окне с F01
// независимо от положения курсора
void GClkMr()
{
  //читать GcntM, перекодировать и
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[2] = GcntM;
  if (TehWind[2] >=10)
   {
    TehWind[3] = TehWind[2] / 10;
    TehWind[2] = TehWind[2] - (TehWind[3] * 10);
   }
   else {TehWind[3] = 0;}
  //задать разрешение изменений в EnWindF[3]=1:EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0
  EnWindF[5] = 0;
  EnWindF[3] = 1; EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[3]=6:ModWind[2]=10
  ModWind[3] = 6; ModWind[2] = 10;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = Gclock_iZnak(TehWind[3]);
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkMw()
{ byte temp = 0;
  // проверить корректность значений в TehWind[3]:TehWind[2]
  // для данного параметра
  //если значения некорректны для TehWind[2],
  //то записать там максимально допустимое и выход
  //в режим ввода параметров (предыдущее состояние)
  // если все корректно то
  // запись значений из TehWind[3]:TehWind[2] в
  //GcntM и adr_rtc_min (при наличии) и после
  //соответствующей перекодировки
  temp = (TehWind[3] * 10) + TehWind[2];
  if (temp <= 59){
  //свертка даных в байт и запись в adr_rtc_min
  // ( * предпочтительно с предварительной
  // остановкой счета и обнулением секунд*)
  GcntM = temp;
  temp = (TehWind[3]<<4) | TehWind[2];
  wrbRamRtc(adr_rtc_min, temp);
  GClkMc();
  }
  else {}
 //если некорректность - издать звук ошибки
 //и оставить текущий режим для повтора ввода или выхода
}

// возврат к выборке субменю без записи
// внесенных изменений
// кнопка "Dn" при курсоре в окне "?"
void GClkMc()
{
  //задать разрешение изменений в EnWindF[5]=1
  EnWindF[5] = 1;
  //запретить изменения для EnWindF[3]=0:EnWindF[2]=0
  EnWindF[3] = 0; EnWindF[2] = 0; EnWindF[0] = 0;
  //заполнить v_ram[3]:v_ram[2] fnt_bl (пробелами)
  my72.v_ram[3] = fnt_bl; my72.v_ram[2] = fnt_bl;
  //сбросить курсор в позиции "?"
  my72.v_ram[0] = my72.v_ram[0] & (~fnt_coma);
  //установить курсор в window_ptr=5 (под "F00.")
  window_ptr = 5;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //вывод v_ram на дисплей
  my72.write_s();
  // восстановлено действие RK
  key_vektor[NumV_Ex] = RK_key; FflagW = 0;
}

//.....................................................................
// просмотр/редактрование значений часов (00-23)
// курсор в окне субменю устройста
// RK при открытом окне с F02
// независимо от положения курсора
void GClkHr()
{
  //читать GcntH, перекодировать и
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[2] = GcntH;
  if (TehWind[2] >=10)
   {
    TehWind[3] = TehWind[2] / 10;
    TehWind[2] = TehWind[2] - (TehWind[3] * 10);
   }
   else {TehWind[3] = 0;}
  //задать разрешение изменений в EnWindF[3]=1:EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0
  EnWindF[5] = 0;
  EnWindF[3] = 1; EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[3]=3:ModWind[2]=10
  ModWind[3] = 3; ModWind[2] = 10;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = Gclock_iZnak(TehWind[3]);
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkHw()
{ byte temp = 0;
  // проверить корректность значений в TehWind[3]:TehWind[2]
  // для данного параметра
  //если значения некорректны для TehWind[2],
  //то записать там максимально допустимое и выход
  //в режим ввода параметров (предыдущее состояние)
  // если все корректно то
  // запись значений из TehWind[3]:TehWind[2] в
  //GcntH и adr_rtc_hours (при наличии) и после
  //соответствующей перекодировки
  temp = (TehWind[3] * 10) + TehWind[2];
  if (temp <= 23){
  //свертка даных в байт и запись в GcntH и adr_rtc_hours
  // ( * предпочтительно с предварительной
  // остановкой счета и обнулением секунд*)
  GcntH = temp;
  temp = (TehWind[3]<<4) | TehWind[2];
  wrbRamRtc(adr_rtc_hours, temp);
  GClkMc();
  }
  else {}
 //если некорректность - издать звук ошибки
 //и оставить текущий режим для повтора ввода или выхода
}

//.....................................................................
// просмотр/редактрование значений дня недели (1-7)
// курсор в окне субменю устройста
// RK при открытом окне с F03
// независимо от положения курсора
void GClkDayr()
{
  //читать adr_rtc_day, перекодировать и
  //вывести данные в TehWind[2]
  TehWind[2] = rdbRamRtc(adr_rtc_day);
  //задать разрешение изменений в EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0, EnWindF[3]=0
  EnWindF[5] = 0; EnWindF[3] = 0;
  EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[2]=8
  ModWind[2] = 8;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[2]
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  my72.v_ram[3] = fnt_bl;
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkDayw()
{
  // проверить корректность значений в TehWind[2]
  // для данного параметра
  //если значения некорректны для TehWind[2],
  //то выход
  //в режим ввода параметров (предыдущее состояние)
  // если все корректно то
  // запись значений из TehWind[2] в
  // adr_rtc_day (при наличии) и после
  //соответствующей перекодировки
  if (TehWind[2] != 0)
   {
    wrbRamRtc(adr_rtc_day, TehWind[2]);
    GClkMc();
   }
   else {}
 //если некорректность - издать звук ошибки
 //и оставить текущий режим для повтора ввода или выхода
}

//.....................................................................
// просмотр/редактрование значений даты (1-31)
// курсор в окне субменю устройста
// RK при открытом окне с F04
// независимо от положения курсора
void GClkDater()
{
  //читать adr_rtc_date, перекодировать и
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[2] = rdbRamRtc(adr_rtc_date);
  TehWind[3] = (TehWind[2] >> 4) & B00001111;
  TehWind[2] = TehWind[2] & B00001111;
  //задать разрешение изменений в EnWindF[3]=1:EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0
  EnWindF[5] = 0;
  EnWindF[3] = 1; EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[3]=3:ModWind[2]=10
  ModWind[3] = 3; ModWind[2] = 10;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = Gclock_iZnak(TehWind[3]);
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkDatew()
{ byte temp = 0;
  // проверить корректность значений в TehWind[3]:TehWind[2]
  // для данного параметра
  //если значения некорректны для TehWind[2],
  //то записать там максимально допустимое и выход
  //в режим ввода параметров (предыдущее состояние)
  // если все корректно то
  // запись значений из TehWind[3]:TehWind[2] в
  // adr_rtc_date (при наличии) и после
  //соответствующей перекодировки
  temp = (TehWind[3] * 10) + TehWind[2];
  if ((temp <= 31) & (temp !=0)){
  //свертка даных в байт и запись в adr_rtc_min
  // ( * предпочтительно с предварительной
  // остановкой счета и обнулением секунд*)
  temp = (TehWind[3]<<4) | TehWind[2];
  wrbRamRtc(adr_rtc_date, temp);
  GClkMc();
  }
  else {}
 //если некорректность - издать звук ошибки
 //и оставить текущий режим для повтора ввода или выхода
}

//.....................................................................
// просмотр/редактрование значений месяца (1-12)
// курсор в окне субменю устройста
// RK при открытом окне с F05
// независимо от положения курсора
void GClkMonsr()
{
  //читать adr_rtc_mons, перекодировать и
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[2] = rdbRamRtc(adr_rtc_mons);
  TehWind[3] = (TehWind[2] >> 4) & B00001111;
  TehWind[2] = TehWind[2] & B00001111;
  //задать разрешение изменений в EnWindF[3]=1:EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0
  EnWindF[5] = 0;
  EnWindF[3] = 1; EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[3]=3:ModWind[2]=10
  ModWind[3] = 2; ModWind[2] = 10;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = Gclock_iZnak(TehWind[3]);
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkMonsw()
{ byte temp = 0;
  // проверить корректность значений в TehWind[3]:TehWind[2]
  // для данного параметра
  //если значения некорректны для TehWind[2],
  //то записать там максимально допустимое и выход
  //в режим ввода параметров (предыдущее состояние)
  // если все корректно то
  // запись значений из TehWind[3]:TehWind[2] в
  // adr_rtc_mons (при наличии) и после
  //соответствующей перекодировки
  temp = (TehWind[3] * 10) + TehWind[2];
  if ((temp <= 12) & (temp !=0)){
  //свертка даных в байт и запись в adr_rtc_min
  // ( * предпочтительно с предварительной
  // остановкой счета и обнулением секунд*)
  temp = (TehWind[3]<<4) | TehWind[2];
  wrbRamRtc(adr_rtc_mons, temp);
  GClkMc();
  }
  else {}
 //если некорректность - издать звук ошибки
 //и оставить текущий режим для повтора ввода или выхода
}

//.....................................................................
// просмотр/редактрование значений года (00-99)
// курсор в окне субменю устройста
// RK при открытом окне с F06
// независимо от положения курсора
void GClkEearr()
{
  //читать adr_rtc_year, перекодировать и
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[2] = rdbRamRtc(adr_rtc_year);
  TehWind[3] = (TehWind[2] >> 4) & B00001111;
  TehWind[2] = TehWind[2] & B00001111;
  //задать разрешение изменений в EnWindF[3]=1:EnWindF[2]=1
  //запретить изменения для EnWindF[5]=0
  EnWindF[5] = 0;
  EnWindF[3] = 1; EnWindF[2] = 1; EnWindF[0] = 1;
  //задать модули ModWind[3]=10:ModWind[2]=10
  ModWind[3] = 10; ModWind[2] = 10;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = Gclock_iZnak(TehWind[3]);
  my72.v_ram[2] = Gclock_iZnak(TehWind[2]);
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkEearw()
{
  //свертка даных в байт и запись в adr_rtc_year
  TehWind[2] = (TehWind[3]<<4) | TehWind[2];
  wrbRamRtc(adr_rtc_mons, TehWind[2]);
  GClkMc();
}

//.....................................................................
// запуск отсчета с 00 секунд
// курсор в окне субменю устройста
// RK при открытом окне с F07
// независимо от положения курсора
void GClkstr()
{
  //вывести данные в TehWind[3]:TehWind[2]
  TehWind[3] = 0; TehWind[2] = 0;
  EnWindF[5] = 0; EnWindF[3] = 0;
  EnWindF[2] = 0; EnWindF[0] = 1;
  //задать модули ModWind[3]=1:ModWind[2]=1
  ModWind[3] = 1; ModWind[2] = 1;
  //установить курсор в window_ptr=0 (под "?")
  window_ptr = 0;
  my72.v_ram[window_ptr] = my72.v_ram[window_ptr] | fnt_coma;
  //записать перекодированные значения в v_ram[3]:v_ram[2]
  my72.v_ram[3] = fnt_0; my72.v_ram[2] = fnt_0;
  //считать данные из v_ram[6]:v_ram[5], удалить из них
  //курсор-запятую и записать результат назад
  my72.v_ram[6] = my72.v_ram[6] & (~fnt_coma);
  my72.v_ram[5] = my72.v_ram[5] & (~fnt_coma);
  //вывод v_ram на дисплей
  my72.write_s();
  // RK заблокировано до операций исполнения/отмены ввода
  key_vektor[NumV_Ex] = key_block;
  // окно параметров открыто
  FflagW = 1;
}

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
void GClkstw()
{
  wrbRamRtc(adr_rtc_sec, 0);
  GClkMc();
}







//.....................................................................

//.....................................................................
//.....................................................................
//.....................................................................

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//------------------------------------------------------------------------

//------------------------------------------------------------------------
//-------------конец файла/end of file---------------------
