/* ----------------------------------------------------- */
/* заголовочный файл функций устройства "главные часы"
                    myclock.h                            */
//-------------------------------------------------------
#ifndef _MYCLOCK_H        // Блокируем повторное включение этого модуля
#define _MYCLOCK_H
//------------------------------------------------------------------------
// обязательная "магическая добавка" (начало)
#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif
// обязательная "магическая добавка" (конец)
//------------------------------------------------------------------------
#include "skans.h" // файл физического сканера клавиатуры
#include "genkey.h" // общие функции (дисплей,главные часы, клавиатура)
#include "max72m.h" // заголовочный *.h файл комплекта библиотеки max72m
#include "mxiicr.h" // заголовочный *.h файл комплекта библиотеки mxiicm
                   // (только физический протокол пересылки байта)
#include "ds1307_map.h" // карта ресурсов DS1307
#include "smart_led.h" // заголовочный *.h файл комплекта библиотеки
                       // Adafruit_NeoPixel

//------------------------------------------------------------------------

//                 главные часы G_Clock

//------------------------------------------------------------------------

//.....................................................................
// запуск функции активации главного меню
// из работающего окна индикации устройства
// "главные часы" (индекс в StartFInd = 0x00)
extern void GClkMm();

// запуск функции активации рабочего режима
// устройства "главные часы"
// (индикация показаний)
// индекс в StartFInd и ячейке AdrRtcFInd
// заменяется на 0x00
extern void GClkMi();

//.....................................................................
// функции режима просмотра/ввода значений
// субменю главных часов

// просмотр/редактрование значений минут (00-59)
// курсор в окне субменю устройста
// RK при открытом окне с F01
// независимо от положения курсора
extern void GClkMr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkMw();

// возврат к выборке субменю без записи
// внесенных изменений
// кнопка "Dn" при курсоре в окне "?"
extern void GClkMc();

//.....................................................................
// просмотр/редактрование значений часов (00-23)
// курсор в окне субменю устройста
// RK при открытом окне с F02
// независимо от положения курсора
extern void GClkHr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkHw();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................
// просмотр/редактрование значений дня недели (1-7)
// курсор в окне субменю устройста
// RK при открытом окне с F03
// независимо от положения курсора
extern void GClkDayr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkDayw();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................
// просмотр/редактрование значений даты (1-31)
// курсор в окне субменю устройста
// RK при открытом окне с F04
// независимо от положения курсора
extern void GClkDater();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkDatew();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................
// просмотр/редактрование значений месяца (1-12)
// курсор в окне субменю устройста
// RK при открытом окне с F05
// независимо от положения курсора
extern void GClkMonsr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkMonsw();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................
// просмотр/редактрование значений года (00-99)
// курсор в окне субменю устройста
// RK при открытом окне с F06
// независимо от положения курсора
extern void GClkEearr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkEearw();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................
// запуск отсчета с 00 секунд
// курсор в окне субменю устройста
// RK при открытом окне с F07
// независимо от положения курсора
extern void GClkstr();

// возврат к выборке субменю с записью
// внесенных изменений
// кнопка "Up" при курсоре в окне "?"
extern void GClkstw();

// выход из просмотра без смены параметров
// аналогичен GClkMc()

//.....................................................................

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------


//------------------------------------------------------------------------

#endif      // Закрывающий #endif к блокировке повторного включения

//-------------конец файла/end of file---------------------
