
//-------------------------------------------------------
 #ifndef _PRVT2_H  // Блокируем повторное включение этого модуля
 #define _PRVT2_H

//------------------
// подключение функционала референса arduinoIDE
#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif

//------------------
// #include <avr/pgmspace.h> // подключить библиотеку работ с таблицами в ПЗУ
// #include "nju6432m.h" // относится к библиотеке, обслуживающей дисплей nju6432m

#include "dhsct.h" // файл глобальных дефайнов текущего проекта
#include "skans.h" // файл физического сканера клавиатуры
#include "genkey.h" // общие функции (дисплей,главные часы, клавиатура)
#include "max72m.h" // заголовочный *.h файл комплекта библиотеки max72m
#include "mxiicr.h" // заголовочный *.h файл комплекта библиотеки mxiicm
                   // (только физический протокол пересылки байта)
#include "ds1307_map.h" // карта ресурсов DS1307
#include "smart_led.h" // заголовочный *.h файл комплекта библиотеки
                       // Adafruit_NeoPixel
#include "ds18b20.h" // заголовочный *.h файл комплекта библиотеки
                     // OneWire
#include "dscrc.h" // подключение самодельной библиотечки расчета CRC8/CRC7
#include "myclock.h" // подключение файла обработчика главных часов
#include "secmetr.h" // подключение файла обработчика секундомера

//-------------------------------------------------------
//------------------------------------------------------------------------------
// раскладка управляющих выводов дисплея для MAX7219
const byte  max_dn = 10; // линия данных дисплея
const byte  max_clk = 11; // тактовый строб сопровождения данных дисплея
const byte  max_cs = 12; // линия разрешения обмена дисплея
//-------------------------------------------------------
// инициализация элементов сканера кнопок
const byte Exec_key = 18; // D18 линия кнопки Exec
const byte Down_key = 17; // D17 линия кнопки Down
const byte Up_key = 16; // D16 линия кнопки Up
const byte Right_key = 15; // D15 линия кнопки Right
const byte Left_key = 14; // D14 линия кнопки Left
//-------------------------------------------------------
// раскладка линий RTC
const byte rtc_sqw = 3; // D3 or INT1
const byte rtc_sda = 4;
const byte rtc_scl = 5;
//-------------------------------------------------------
// раскладка линий uLan
const byte DQ = 6; // D6
//-------------------------------------------------------
// раскладка линий Smart_Led
const byte Smart_Led = 7; // D7

//-------------------------------------------------------
// дополнительный генератор тайм-сетки

volatile byte FCnt_A; // флаг 20mS
volatile byte FCnt_B; // флаг 1S

void GClkInit(); // инициализация аппаратной части

//-------------------------------------------------------
// селектор функций устройств, запускаемых при подаче питания
// согласно содержимого энергонезависимой RAM RTC

extern void actuator();

//-------------------------------------------------------




#endif

//-------------конец файла/end of file---------------------
