
//*****************************************************************
//  Секция include: здесь подключается заголовочный файл к модулю
//*****************************************************************
#include "prvt2.h" // заголовочный *.h файл текущего проекта

//**************************************************
//       Секция создания экземпляров классов
//  задаем соответствие физических линий интерфейса
//         и передаваемых параметров
//      закрытым переменным членам класса
//***************************************************

// создание экземпляра класса m72
m72 my72(max_dn, max_clk, max_cs);

// создание класса mxiic
mxiic my_iic(rtc_sda, rtc_scl);

// массив данных блокнота для DS18B20
byte data[9];

//------------------------------------------------

//*************************************************
//       Секция начальной инициализации setup
//   (выполняется однократно при запуске системы)
//*************************************************

void setup() {
  // put your setup code here, to run once:

// Serial.begin(9600); // for tests
// инициализация управляющих выводов индикатора
 my72.init();
// запуск индикатора
 disp_init();
// инициализация сканера кнопок
 vkskan_init();
// блокировка векторного селектора клавиатуры
 KeyStartInit();
// инициализация аппаратной части
// генератора вспомогательной тайм-сетки
 GClkInit();
// инициализация управляющих выводов iic/rtc
 my_iic.mx_init();
// инициализация идикатора силовой цепи
 digitalWrite(Led_Out, LOW); pinMode(Led_Out, OUTPUT);
//      загрузка индекса в "пустую" RTC
// (перед подачей питания зажать кнопку Exec_key)
 ColdStart();
// запуск с уже активированным индексом
 actuator();
 my_Smart_Led.begin();
}

//***************************************************
//  Секция основной программы (в обычном Си = main)
//***************************************************

void loop() {
  // put your main code here, to run repeatedly:

if (FCnt_A){FCnt_A=0; vkskan();}
if (key_flag){key_vektor[key_tmp2](); key_flag=0;}

if (bitRead(G_ClkF, Qt_ClkInd)){Gclock_ind();}
if (bitRead(SecMetrF, Qt_SecMetr)){SecMetr_ind();}
 
    
 





}

//------------------------------------------------

//***************************************************
//              ПОДВАЛ С ФУНКЦЯМИ
//***************************************************

//----------------------------------------------------------------
// обработчик прерывания дополнительной тайм-сетки
SIGNAL(TIMER0_COMPA_vect)
{
  static byte Cnt_A=0; static byte Cnt_B=0;
  Cnt_A++;
  if (Cnt_A == 20){ Cnt_A=0; FCnt_A=1; Cnt_B++; }
  if (Cnt_B == 50)
  { 
    Cnt_B=0; FCnt_B=1;
    Gclock_work();
    SecMetr_wrk();
  }
}

// инициализация аппаратной части
// генератора вспомогательной тайм-сетки
void GClkInit()
{
 noInterrupts();
 OCR0A=127; TIMSK0 |= (1<<OCIE0A);
 FCnt_A=0; FCnt_B=0;
 interrupts();
}

//----------------------------------------------------------------
//.....................................................................
// селектор функций устройств, запускаемых при подаче питания
// согласно содержимого энергонезависимой RAM RTC
void actuator()
{
  //считать AdrRtcFInd в StartFInd из RAM RTC
  StartFInd = rdbRamRtc(AdrRtcFInd);
  selFind();
}

//----------------------------------------------------------------

//----------------------------------------------------------------

//----------------------------------------------------------------

//----------------------------------------------------------------


//-------------конец файла/end of file---------------------
