//******************************************************************************
//  Секция include: здесь подключается заголовочный файл к модулю
//******************************************************************************

#include "secmetr.h" // заголовочный *.h файл текущего проекта

//------------------------------------------------------------------------

//            секундомер SecMetr

//------------------------------------------------------------------------

// байт флагов секундомера
volatile byte SecMetrF = 0;

// основные счетчики секундомера
volatile byte SMS_cnt = 0; // счетчик секунд секундомера
volatile byte SMM_cnt = 0; // счетчик минут секундомера
volatile byte SMH_cnt = 0; // счетчик часов секундомера

// блок временной памяти результата секундомера (уставка таймера)
volatile byte SMS_Ram; // РВХ секунд секундомера/таймера
volatile byte SMM_Ram; // РВХ минут секундомера/таймера
volatile byte SMH_Ram; // РВХ часов секундомера/таймера

//.....................................................................
//// функция обработчика контроля и приращения
// счетчиков секундомера
void SecMetr_wrk()
{
 if (bitRead(SecMetrF, En_SecMetr))
      {
       SMS_cnt++; bitSet(SecMetrF, Qt_SecMetr);
        if (SMS_cnt==mod60)
         {
          SMS_cnt =0; SMM_cnt++;
           if (SMM_cnt==mod60)
            {
             SMM_cnt =0; SMH_cnt++;
              if (SMH_cnt==mod60){GcntH =0;}
            }
         }
      }
}

// основной модуль вывода на индикацию показаний секундомера
void SecMetr_ind()
{
if (bitRead(SecMetrF, En_SecMetr))
  {
    if (SMS_cnt >= 10)
     {
      my72.v_ram[Sec_Sh] = Gclock_iZnak((SMS_cnt/10));
      my72.v_ram[Sec_Sl] = Gclock_iZnak((SMS_cnt - ((SMS_cnt/10)*10)));
     }
    else 
     {
      my72.v_ram[Sec_Sh] = fnt_0;
      my72.v_ram[Sec_Sl] = Gclock_iZnak(SMS_cnt);
     }
    if (SMM_cnt >= 10)
     {
      my72.v_ram[Sec_Mh] = Gclock_iZnak((SMM_cnt/10));
      my72.v_ram[Sec_Ml] = Gclock_iZnak((SMM_cnt - ((SMM_cnt/10)*10)));
     }
    else 
     {
      my72.v_ram[Sec_Mh] = fnt_0;
      my72.v_ram[Sec_Ml] = Gclock_iZnak(SMM_cnt);
     }
    if (SMH_cnt >= 10)
     {
      my72.v_ram[Sec_Hh] = Gclock_iZnak((SMH_cnt/10));
      my72.v_ram[Sec_Hl] = Gclock_iZnak((SMH_cnt - ((SMH_cnt/10)*10)));
     }
    else 
     {
      my72.v_ram[Sec_Hh] = fnt_bl;
      my72.v_ram[Sec_Hl] = Gclock_iZnak(SMH_cnt);
     }
    my72.v_ram[Sec_Ml] = my72.v_ram[Sec_Ml] | fnt_coma;
    my72.v_ram[Sec_Hl] = my72.v_ram[Sec_Hl] | fnt_coma;
   my72.write_s(); // вывод v_ram в индикатор
  }
 bitClear(SecMetrF, Qt_SecMetr); // сброс флага запроса в любом случае
}

//.....................................................................
// запуск функции активации главного меню
// из работающего окна индикации устройства
// "секундомер" (индекс в StartFInd = 0x10)
// RK из режима текущей индикации устройства
//
void SecMetrM()
{
 // заблокированы в пассивном состоянии
 // внешние силовые выводы

 // запрещена индикация главных часов при
 // сохранении хода
  G_ClkF = G_ClkF & (~En_ClkInd);
 // запрещены индикация и ход секундомера
 SecMetrF = 0;
 //счетчики секундомера обнулены
 SMS_cnt = 0; SMM_cnt = 0; SMH_cnt =0;
 // мoдуль счета для разрешенных позиций субменю
 // передается аргументом в masterMM
 //ModWind[5] = 1;
 masterMM(1);
}


//.....................................................................
// запуск функции активации рабочего режима
// устройства "секундомер"
// (индикация показаний) RK в меню
// индекс в StartFInd и ячейке AdrRtcFInd
// заменяется на 0x10
void SecMetrI()
{
 // разблокированы (возвращен текущий статус)
 // внешние силовые выводы

 // запрещены ход и индикация главных часов (страховка)
  G_ClkF=G_ClkF & (!((1<<En_Clock) | (1<<En_ClkInd)));
 // запрещены ход и индикация секундомера
  SecMetrF = 0;
 // инициализация исходного состояния (блокировка)
 // векторного селектора клавиатуры и селектора меню
  StartIniLabel();
  
  SstartWind();

 // запрещен ход при разрешении индикация значений секундомера
 // разрешение/запрет хода осуществляется соответствующей кнопкой
  SecMetrF = 1<<EnI_SeMetr;
 // разрешено обслуживание кноп
  key_vektor[NumV_Zs] = OllOff;
  key_vektor[NumV_Ex] = RK_key; // только на время заставки
  // при работе до момента сброса RK_key блокирована
  key_vektor[NumV_Dn] = sReset;// сброс показаний (при статусе стоп), разрешает RK
  key_vektor[NumV_Up] = StarStop_S;// старт/стоп отсчета, запрещает RK
  key_vektor[NumV_Ri] = sMemWr;// перезапись в буфер (при статусе стоп)
  key_vektor[NumV_Le] = key_block;
}

//.....................................................................
// кнопка "старт/стоп" (Up_key, номер вектора в key_vektor[] - NumV_Up)
void StarStop_S()
{
 if (!bitRead(trig_flags, Up_trigF))
 {
  bitSet(trig_flags, Up_trigF);
  key_vektor[NumV_Ex] = key_block;
 if (bitRead(SecMetrF, En_SecMetr))
  { // STOP
    bitClear(SecMetrF, En_SecMetr); my72.v_ram[0] = fnt_o;
  }
 else
  { // START
    bitSet(SecMetrF, En_SecMetr); my72.v_ram[0] = fnt_gradus;
  }
 my72.write_s();
 }
}

// кнопка "сброс" (Down_key, номер вектора в key_vektor[] - NumV_Dn)
// работает только при стаусе "стоп"
void sReset()
{
 if (!bitRead(trig_flags, Dn_trigF))
 {
  bitSet(trig_flags, Dn_trigF);
   if (!(bitRead(SecMetrF, En_SecMetr)))
    {
     key_vektor[NumV_Ex] = RK_key;
     SstartWind();
   }
 }
}

// кнопка "запомнить" (Right_key, номер вектора в key_vektor[] - NumV_Ri)
// работает только при стаусе "стоп"
void sMemWr()
{
 if (!bitRead(trig_flags, Ri_trigF))
  {
   //установить флаг блокировки повторного исполнения
   bitSet(trig_flags, Ri_trigF);
    if (!(bitRead(SecMetrF, En_SecMetr)))
     {
      SMS_Ram = SMS_cnt;
      SMM_Ram = SMM_cnt;
      SMH_Ram = SMH_cnt;
      my_Smart_Led.setPixelColor(0,0,0,255);
      my_Smart_Led.setBrightness(255);
      my_Smart_Led.show();
      delay(500);
      my_Smart_Led.setPixelColor(0,0,0,0);
      my_Smart_Led.show();
     }
  }
}

// кнопка Left_key, номер вектора в key_vektor[] - NumV_Le блокирована
// с помощью key_block()


// окно - заставка исходного состояния индикаторов
void SstartWind()
{
   // очистка счетчиков
     SMS_cnt = 0; SMM_cnt = 0; SMH_cnt =0;
  // предочистка массива v_ram
     clr_mas(my72.v_ram, fnt_bl);
 // заполнение заставкой
     my72.v_ram[6] = fnt_0 | fnt_coma; my72.v_ram[4] = fnt_0 | fnt_coma;
     my72.v_ram[5] = fnt_0;
     my72.v_ram[3] = fnt_0; my72.v_ram[2] = fnt_0;
     my72.v_ram[0] = fnt_o;
  // с выводом на индикацию
     my72.write_s();
}



//.....................................................................

//.....................................................................
//.....................................................................
//.....................................................................

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

//------------------------------------------------------------------------

//------------------------------------------------------------------------
//-------------конец файла/end of file---------------------
