/* ----------------------------------------------------- */
/* заголовочный файл функций устройства "главные часы"
                    secmetr.h                            */
//-------------------------------------------------------
#ifndef _SECMETR_H        // Блокируем повторное включение этого модуля
#define _SECMETR_H
//------------------------------------------------------------------------
// обязательная "магическая добавка" (начало)
#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif
// обязательная "магическая добавка" (конец)
//------------------------------------------------------------------------
#include "skans.h" // файл физического сканера клавиатуры
#include "genkey.h" // общие функции (дисплей,главные часы, клавиатура)
#include "max72m.h" // заголовочный *.h файл комплекта библиотеки max72m
#include "mxiicr.h" // заголовочный *.h файл комплекта библиотеки mxiicm
                   // (только физический протокол пересылки байта)
#include "ds1307_map.h" // карта ресурсов DS1307
#include "smart_led.h" // заголовочный *.h файл комплекта библиотеки
                       // Adafruit_NeoPixel

//------------------------------------------------------------------------

//                 секундомер SecMetr

//------------------------------------------------------------------------

// байт флагов секундомера
extern volatile byte SecMetrF;
// флаг разрешения счета для счетчиков
#define En_SecMetr 0
// флаг разрешения вывода значений
// секундомера на индикацию
#define EnI_SeMetr 1
// флаг запроса обработки вывода на индикацию
// очередного изменения содержимого счетчиков секунд,
// минут и часов секундомера
#define Qt_SecMetr 2
// триггер-флаг для кнопки "старт/стоп"
#define SSt_trigS 3

// основные счетчики секундомера
extern volatile byte SMS_cnt; // счетчик секунд секундомера
extern volatile byte SMM_cnt; // счетчик минут секундомера
extern volatile byte SMH_cnt; // счетчик часов секундомера

// блок временной памяти результата секундомера (уставка таймера)
extern volatile byte SMS_Ram; // РВХ секунд секундомера/таймера
extern volatile byte SMM_Ram; // РВХ минут секундомера/таймера
extern volatile byte SMH_Ram; // РВХ часов секундомера/таймера

// раскладка дисплея секундомера
// #define ST_stec 0 // окно уровней стека памяти предыдущих результатов
#define SwrkInd 0 // окно индикатора "отсчет/останов"
#define S_blanc 1 // пробел
#define Sec_Sl 2 // секунды младший знак
#define Sec_Sh 3 // секунды старший знак
#define Sec_Ml 4 // минуты младший знак и децимальная точка-разделитель
#define Sec_Mh 5 // минуты старший знак
#define Sec_Hl 6 // часы младший знак и децимальная точка-разделитель
#define Sec_Hh 7 //часы старший знак

//.....................................................................
//// функция обработчика контроля и приращения
// счетчиков секундомера
extern void SecMetr_wrk();

// основной модуль вывода на индикацию показаний секундомера
extern void SecMetr_ind();

//.....................................................................
// запуск функции активации главного меню
// из работающего окна индикации устройства
// курсор в окне главных меню устройств
// "секундомер" (индекс в StartFInd = 0x10)
// (кнопка RK (Exec_key номер вектора NumV_Ex))
extern void SecMetrM();

// запуск функции активации рабочего режима
// устройства "секундомер"
// (индикация показаний)
// индекс в StartFInd и ячейке AdrRtcFInd
// заменяется на 0x10
// (кнопка RK (Exec_key номер вектора NumV_Ex))
extern void SecMetrI();

//.....................................................................
// кнопка "старт/стоп" (Up_key, номер вектора в key_vektor[] - NumV_Up)
extern void StarStop_S();
// кнопка "сброс" (Down_key, номер вектора в key_vektor[] - NumV_Dn)
extern void sReset();

// кнопка "запомнить" (Right_key, номер вектора в key_vektor[] - NumV_Ri)
void sMemWr();

// кнопка Left_key, номер вектора в key_vektor[] - NumV_Le блокирована
// с помощью key_block()

// окно - заставка исходного состояния индикаторов
extern void SstartWind();

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------


//------------------------------------------------------------------------

#endif      // Закрывающий #endif к блокировке повторного включения

//-------------конец файла/end of file---------------------
