//******************************************************************************
//  Секция include: здесь подключается заголовочный файл к модулю
//******************************************************************************

#include "skans.h" // заголовочный *.h файл текущего проекта

//------------------------------------------------------------------------
const byte NumV_Zs = 0; // номер позиции вектора в массиве key_vektor
                          // для статуса "все кнопки отпущены"
const byte NumV_Ex = 1; // номер позиции вектора в массиве key_vektor
                          // для кнопки Exec
const byte NumV_Dn = 2; // номер позиции вектора в массиве key_vektor
                          // для кнопки Down
const byte NumV_Up = 3; // номер позиции вектора в массиве key_vektor
                        // для кнопки Up
const byte NumV_Ri = 4; // номер позиции вектора в массиве key_vektor
                           // для кнопки Right
const byte NumV_Le = 5; // номер позиции вектора в массиве key_vektor
                          // для кнопки Left
const byte max_num = 6; // константа размера массива к-во кноп +1

//------------------------------------------------------------------------------
// определение временных буферов обработчика клавиатуры
volatile byte key_tmp2=0; volatile byte key_flag=0;

//------------------------------------------------------------------------------
// инициализация массива указателей
// векторного селектора клавиатуры
key_ptrv key_vektor[max_num]{};


//******************************************************************************
//  Секция описания функций сканера кнопок
//******************************************************************************
// инициалзация выводов МК

void vkskan_init()
{
 pinMode(Exec_key, INPUT_PULLUP); pinMode(Down_key, INPUT_PULLUP);
 pinMode(Up_key, INPUT_PULLUP); pinMode(Right_key, INPUT_PULLUP);
 pinMode(Left_key, INPUT_PULLUP); pinMode(Right_key, INPUT_PULLUP);
 digitalWrite(Exec_key, HIGH);digitalWrite(Down_key, HIGH);
 digitalWrite(Up_key, HIGH); digitalWrite(Right_key, HIGH);
 digitalWrite(Left_key, HIGH); digitalWrite(Right_key, HIGH);
}

// собственно сканер и преобразователь входной комбинации в номер вектора
// исполняемой функции

void vkskan()
{
  static byte key_tmp0; static byte key_tmp1;
  key_tmp0 = ~((digitalRead(Exec_key)<<0) | (digitalRead(Down_key)<<1) | \
  (digitalRead(Up_key)<<2) | (digitalRead(Right_key)<<3) | \
  (digitalRead(Left_key)<<4));
  key_tmp0 &= B00011111;
  if (key_tmp1 == key_tmp0)
  { 
  switch (key_tmp1){
    case B00000000:
       key_tmp2 = NumV_Zs; key_flag=1;
      break; // 0 все кнопки пассивны
    case B00000001:
       key_tmp2 = NumV_Ex; key_flag=1;
      break; // 1 нажата кнопка Exec
    case B00000010:
       key_tmp2 = NumV_Dn; key_flag=1;
      break; // 2 нажата кнопка Down_key
/*
    case B00000011:
       //key_tmp2 = n; key_flag=1;
      break; // 3 нажата комбинация 
*/
    case B00000100:
       key_tmp2 = NumV_Up; key_flag=1;
      break; // 4 нажата кнопка Up_key
/*
    case B00000101:
       //key_tmp2 = n; key_flag=1;
      break; // 5 нажата комбинация 
    case B00000110:
       //key_tmp2 = n; key_flag=1;
      break; // 6 нажата комбинация 
    case B00000111:
       //key_tmp2 = n; key_flag=1;
      break; // 7 нажата комбинация 
*/
    case B00001000:
       key_tmp2 = NumV_Ri; key_flag=1;
      break; // 8 нажата кнопка Right_key
/*
    case B00001001:
       //key_tmp2 = n; key_flag=1;
      break; // 9 нажата комбинация 
    case B00001010:
       //key_tmp2 = n; key_flag=1;
      break; // 10 нажата комбинация 
    case B00001011:
       //key_tmp2 = n; key_flag=1;
      break; // 11 нажата комбинация 
    case B00001100:
       //key_tmp2 = n; key_flag=1;
      break; // 12 нажата комбинация 
    case B00001101:
       //key_tmp2 = n; key_flag=1;
      break; // 13 нажата комбинация 
    case B00001110:
       //key_tmp2 = n; key_flag=1;
      break; // 14 нажата комбинация 
    case B00001111:
       //key_tmp2 = n; key_flag=1;
      break; // 15 нажата комбинация 
*/
    case B00010000:
       key_tmp2 = NumV_Le; key_flag=1;
      break; // 16 нажата кнопка Left_key
/*
    case B00010001:
       //key_tmp2 = n; key_flag=1;
      break; // 17 нажата кнопка Exec
    case B00010010:
       //key_tmp2 = n; key_flag=1;
      break; // 18 нажата комбинация 
    case B00010011:
       //key_tmp2 = n; key_flag=1;
      break; // 19 нажата комбинация 
    case B00010100:
       //key_tmp2 = n; key_flag=1;
      break; // 20 нажата комбинация 
    case B00010101:
       //key_tmp2 = n; key_flag=1;
      break; // 21 нажата комбинация 
    case B00010110:
       //key_tmp2 = n; key_flag=1;
      break; // 22 нажата комбинация 
    case B00010111:
       //key_tmp2 = n; key_flag=1;
      break; // 23 нажата комбинация 
    case B00011000:
       //key_tmp2 = n; key_flag=1;
      break; // 24 нажата комбинация 
    case B00011001:
       //key_tmp2 = n; key_flag=1;
      break; // 25 нажата комбинация 
    case B00011010:
       //key_tmp2 = n; key_flag=1;
      break; // 26 нажата комбинация 
    case B00011011:
       //key_tmp2 = n; key_flag=1;
      break; // 27 нажата комбинация 
    case B00011100:
       //key_tmp2 = n; key_flag=1;
      break; // 28 нажата комбинация 
    case B00011101:
       //key_tmp2 = n; key_flag=1;
      break; // 29 нажата комбинация 
    case B00011110:
       //key_tmp2 = n; key_flag=1;
      break; // 30 нажата комбинация 
    case B00011111:
       //key_tmp2 = n; key_flag=1;
      break; // 31 нажата комбинация 
*/
    default: 
      key_flag=0;
    break;
   }
  }
   else {key_tmp1=key_tmp0; key_flag=0;}
}

//------------------------------------------------------------------------
// функция блокировки векторного селектора клавиатуры
void key_block(){}

//------------------------------------------------------------------------
//-------------конец файла/end of file---------------------
