/* ---------------------------------------------------- */
/*         заголовочный файл сканера кнопок skans.h     */
//-------------------------------------------------------
#ifndef _SKANS_H        // Блокируем повторное включение этого модуля
#define _SKANS_H
//------------------------------------------------------------------------
// обязательная "магическая добавка" (начало)
#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif
// обязательная "магическая добавка" (конец)
//------------------------------------------------------------------------
// определяем тип "указатель на функцию"
typedef void(*key_ptrv)();
//------------------------------------------------------------------------
// опеделение/инициализация элементов сканера кнопок
extern const byte Exec_key; // D18 линия кнопки Exec
extern const byte Down_key; // D17 линия кнопки Down
extern const byte Up_key; // D16 линия кнопки Up
extern const byte Right_key; // D15 линия кнопки Right
extern const byte Left_key; // D14 линия кнопки Left

//------------------------------------------------------------------------
extern const byte NumV_Zs; // номер позиции вектора в массиве key_vektor
                          // для статуса "все кнопки отпущены"
extern const byte NumV_Ex; // номер позиции вектора в массиве key_vektor
                          // для кнопки Exec
extern const byte NumV_Dn; // номер позиции вектора в массиве key_vektor
                          // для кнопки Down
extern const byte NumV_Up; // номер позиции вектора в массиве key_vektor
                        // для кнопки Up
extern const byte NumV_Ri; // номер позиции вектора в массиве key_vektor
                           // для кнопки Right
extern const byte NumV_Le; // номер позиции вектора в массиве key_vektor
                          // для кнопки Left

//------------------------------------------------------------------------
// временные буферы обработчика клавиатуры
extern volatile byte key_tmp2, key_flag;

//------------------------------------------------------------------------
// массив указателей на функции обработчиков типа key_ptrv
// размер зависит от количества разрешенных комбинаций
// плюс статус "все отпущены"
// минимум 5+1 максимум 32+1
extern const byte max_num;
// объявление массива указателей в соответствии
// с функционалом кнопок (комбинации кнопок)
extern key_ptrv key_vektor[];

//------------------------------------------------------------------------
// функции сканера клавиатуры

// инициализация состояния выводов МК
extern void vkskan_init();
// собственно обработчик-преоьразователь данных
extern void vkskan();
// функция-пустышка абсолютной блокировки кнопы
extern void key_block();

//------------------------------------------------------------------------

#endif      // Закрывающий #endif к блокировке повторного включения

//-------------конец файла/end of file---------------------
